---
title: 'Recipe: Media objects'
slug: Web/CSS/Layout_cookbook/Media_objects
tags:
  - CSS
  - Guide
  - Layout
  - Media object
  - cookbook
  - fit-content
  - float
  - grid
---
<div>{{CSSRef}}</div>

<p class="summary">The <em>Media Object</em> is a pattern we see all over the web. <a href="http://www.stubbornella.org/content/2010/06/25/the-media-object-saves-hundreds-of-lines-of-code/">Named by Nicole Sullivan</a> it refers to a two-column box with an image on one side and descriptive text on the other, e.g. a facebook post or tweet.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16112/media-object.png"></p>

<h2 id="Requirements">Requirements</h2>

<p>Media Object pattern needs some or all of the following characteristics:</p>

<ul>
 <li>Stacked on Mobile, two columns on Desktop.</li>
 <li>The image can be on the left or right.</li>
 <li>The image might be small or large.</li>
 <li>Media Objects can be nested.</li>
 <li>The Media Object should clear the contents no matter which side is tallest.</li>
</ul>

<h2 id="The_recipe">The recipe</h2>

<p class="codepen">{{EmbedGHLiveSample("css-examples/css-cookbook/media-objects.html", '100%', 1200)}}</p>

<div class="note">
<p class="codepen"><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/media-objects--download.html">Download this example</a></p>
</div>

<h2 id="Choices_made">Choices made</h2>

<p>I have chosen to use <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">Grid Layout</a> for the media object as it allows me to control the layout in two dimensions when I need to. This means that when we have a footer, with short content above, the footer can be pushed down to the bottom of the media object.</p>

<p>Another reason to use Grid Layout is in order that I can use {{cssxref("fit-content")}} for the track sizing of the image. By using <code>fit-content</code> with a maximum size of 200 pixels, when we have a small image such as the icon, the track only gets as large as the size of that image — the <code>max-content</code> size. If the image is larger, the track stops growing at 200 pixels and as the image has a {{cssxref("max-width ")}} of 100% applied, it scales down so that it continues to fit inside the column.</p>

<p>By using {{cssxref("grid-template-areas")}} to achieve the layout, I can see the pattern in the CSS. I define my grid once we have a max-width of 500 pixels, so on smaller devices the media object stacks.</p>

<p>An option for the pattern is to flip it to switch the image to the other side — this is done by adding the <code>media-flip</code> class, which defines a flipped grid template causing the layout to be mirrored.</p>

<p>When we nest one media object inside another we need to place it into the second track in the regular layout, and the first track when flipped.</p>

<h2 id="Fallbacks">Fallbacks</h2>

<p>There are a number of possible fallbacks for this pattern, depending on the browsers you wish to support. A good catch-all would be to float the image left, and to add a clearfix to the box to ensure that it contained the floats.</p>

<p class="codepen">{{EmbedGHLiveSample("css-examples/css-cookbook/media-objects-fallback.html", '100%', 1200)}}</p>

<div class="note">
<p class="codepen"><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/media-objects-fallback--download.html">Download this example</a></p>
</div>

<p>Once floated elements become grid items the float no longer applies so you don’t need to do anything special to clear the float.</p>

<p>What you will need to do is remove any margins applied to the item, and any widths which we don’t need in a grid context (we have the {{cssxref("gap")}} property to control it in grids, and the track takes control of the sizing).</p>

<h2 id="Relevant_resources_on_MDN">Relevant resources on MDN</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layout</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_and_Progressive_Enhancement">Progressive Enhancement and Grid Layout</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas">Using Grid Template Areas</a></li>
 <li><a href="/en-US/docs/Web/CSS/fit-content">fit-content</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas">Grid-template-areas</a></li>
</ul>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The various layout methods have different browser support. See the charts below for details on basic support for the properties used.</p>

<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<h4 id="grid-template-areas">grid-template-areas</h4>

<p>{{Compat("css.properties.grid-template-areas")}}</p>

<h4 id="float">float</h4>

<p>{{Compat("css.properties.float")}}</p>
